ripley Namespace Reference

## Classes

class | AbstractAssembler
class | Brick
| Brick is the 3-dimensional implementation of a RipleyDomain. More...
class | DefaultAssembler2D
class | DefaultAssembler3D
struct | DiracPoint
| A struct to contain a dirac point's information. More...
class | LameAssembler2D
class | LameAssembler3D
class | MultiBrick
| Brick is the 3-dimensional implementation of a RipleyDomain. More...
class | MultiRectangle
| Rectangle is the 2-dimensional implementation of a RipleyDomain. More...
struct | ReaderParameters
| Structure that wraps parameters for the grid reading routines. More...
class | Rectangle
| Rectangle is the 2-dimensional implementation of a RipleyDomain. More...
class | RipleyDomain
| RipleyDomain extends the AbstractContinuousDomain interface for the Ripley library and is the base class for Rectangle and Brick. More...
class | RipleyException
| RipleyException exception class. More...
class | SystemMatrix
class | WaveAssembler2D
class | WaveAssembler3D

## Typedefs

typedef std::map< std::string, escript::Data > | DataMap
typedef std::pair< index_t, index_t > | IndexPair
typedef std::vector< index_t > | IndexVector
typedef std::vector< real_t > | DoubleVector
typedef std::vector< int > | RankVector
typedef std::map< std::string, int > | TagMap
typedef cusp::cds_matrix< int, double, cusp::host_memory > | HostMatrixType
typedef cusp::cds_matrix< int, double, cusp::device_memory > | DeviceMatrixType
typedef cusp::array1d< double, cusp::host_memory > | HostVectorType
typedef cusp::array1d< double, cusp::device_memory > | DeviceVectorType

## Enumerations

enum | { DegreesOfFreedom =1, ReducedDegreesOfFreedom =2, Nodes =3, ReducedNodes =14, Elements =4, ReducedElements =10, FaceElements =5, ReducedFaceElements =11, Points =6 }
enum | assembler_t { DEFAULT_ASSEMBLER, WAVE_ASSEMBLER, LAME_ASSEMBLER }
enum | SystemMatrixType { SMT_PASO = 1<<8, SMT_CUSP = 1<<9, SMT_TRILINOS = 1<<10, SMT_SYMMETRIC = 1<<15, SMT_COMPLEX = 1<<16, SMT_UNROLL = 1<<17 }
enum | DecompositionPolicy { DECOMP_ADD_ELEMENTS, DECOMP_EXPAND, DECOMP_STRICT }
enum | { BYTEORDER_NATIVE = BOOST_BYTE_ORDER, BYTEORDER_LITTLE_ENDIAN = 1234, BYTEORDER_BIG_ENDIAN = 4321 }
enum | { DATATYPE_INT32 = 1, DATATYPE_FLOAT32, DATATYPE_FLOAT64 }

## Functions

typedef | POINTER_WRAPPER_CLASS (AbstractAssembler) Assembler_ptr
int | indexOfMax (dim_t a, dim_t b, dim_t c)
void | factorise (std::vector< int > &factors, int product)
const escript::Data | unpackData (const std::string target, const DataMap &mapping)
bool | isNotEmpty (const std::string target, const DataMap &mapping)
void | doublyLink (std::vector< ripley::IndexVector > &va, std::vector< ripley::IndexVector > &vb, int a, int b)
template<typename T >
std::vector< T > | extractPyArray (const object &obj, const std::string &name, int expectedLength=0)
escript::Data | readBinaryGrid (std::string filename, escript::FunctionSpace fs, const object &pyShape, double fill, int byteOrder, int dataType, const object &pyFirst, const object &pyNum, const object &pyMultiplier, const object &pyReverse)
escript::Data | readBinaryGridFromZipped (std::string filename, escript::FunctionSpace fs, const object &pyShape, double fill, int byteOrder, int dataType, const object &pyFirst, const object &pyNum, const object &pyMultiplier, const object &pyReverse)
escript::Data | readNcGrid (std::string filename, std::string varname, escript::FunctionSpace fs, const object &pyShape, double fill, const object &pyFirst, const object &pyNum, const object &pyMultiplier, const object &pyReverse)
escript::Domain_ptr | _brick (double _n0, double _n1, double _n2, const object &l0, const object &l1, const object &l2, int d0, int d1, int d2, const object &objpoints, const object &objtags, escript::SubWorld_ptr world)
escript::Domain_ptr | _multibrick (double _n0, double _n1, double _n2, const object &l0, const object &l1, const object &l2, int d0, int d1, int d2, const object &objpoints, const object &objtags, escript::SubWorld_ptr world, unsigned int multiplier)
escript::Domain_ptr | _multirectangle (double _n0, double _n1, const object &l0, const object &l1, int d0, int d1, const object &objpoints, const object &objtags, escript::SubWorld_ptr world, unsigned int multiplier)
escript::Domain_ptr | _rectangle (double _n0, double _n1, const object &l0, const object &l1, int d0, int d1, const object &objpoints, const object &objtags, escript::SubWorld_ptr world)
void | tupleListToMap (DataMap &mapping, const bp::list &list)
char * | byte_swap32 (char *val)
char * | byte_swap64 (char *val)

## Typedef Documentation

## DataMap

typedef std::map<std::string, escript::Data> ripley::DataMap

## DeviceMatrixType

typedef cusp::cds_matrix<int, double, cusp::device_memory> ripley::DeviceMatrixType

## DeviceVectorType

typedef cusp::array1d<double, cusp::device_memory> ripley::DeviceVectorType

## DoubleVector

typedef std::vector<real_t> ripley::DoubleVector

## HostMatrixType

typedef cusp::cds_matrix<int, double, cusp::host_memory> ripley::HostMatrixType

## HostVectorType

typedef cusp::array1d<double, cusp::host_memory> ripley::HostVectorType

## IndexPair

typedef std::pair<index_t,index_t> ripley::IndexPair

## IndexVector

typedef std::vector<index_t> ripley::IndexVector

## RankVector

typedef std::vector<int> ripley::RankVector

## TagMap

typedef std::map<std::string,int> ripley::TagMap

## Enumeration Type Documentation

## anonymous enum

anonymous enum

Enumerator
DegreesOfFreedom |
ReducedDegreesOfFreedom |
Nodes |
ReducedNodes |
Elements |
ReducedElements |
FaceElements |
ReducedFaceElements |
Points |

## anonymous enum

anonymous enum

Enumerator
BYTEORDER_NATIVE |
BYTEORDER_LITTLE_ENDIAN |
BYTEORDER_BIG_ENDIAN |

## anonymous enum

anonymous enum

Enumerator
DATATYPE_INT32 |
DATATYPE_FLOAT32 |
DATATYPE_FLOAT64 |

## assembler_t

enum ripley::assembler_t

Enumerator
DEFAULT_ASSEMBLER |
WAVE_ASSEMBLER |
LAME_ASSEMBLER |

## DecompositionPolicy

enum ripley::DecompositionPolicy

Enumerator
DECOMP_ADD_ELEMENTS |
DECOMP_EXPAND |
DECOMP_STRICT |

## SystemMatrixType

enum ripley::SystemMatrixType

Enumerator
SMT_PASO |
SMT_CUSP |
SMT_TRILINOS |
SMT_SYMMETRIC |
SMT_COMPLEX |
SMT_UNROLL |

## Function Documentation

## _brick()

escript::Domain_ptr ripley::_brick | ( | double | _n0,
|  | double | _n1,
|  | double | _n2,
|  | const object & | l0,
|  | const object & | l1,
|  | const object & | l2,
|  | int | d0,
|  | int | d1,
|  | int | d2,
|  | const object & | objpoints,
|  | const object & | objtags,
|  | escript::SubWorld_ptr | world
| ) |  |

References paso::util::l2().

Referenced by BOOST_PYTHON_MODULE().

## _multibrick()

escript::Domain_ptr ripley::_multibrick | ( | double | _n0,
|  | double | _n1,
|  | double | _n2,
|  | const object & | l0,
|  | const object & | l1,
|  | const object & | l2,
|  | int | d0,
|  | int | d1,
|  | int | d2,
|  | const object & | objpoints,
|  | const object & | objtags,
|  | escript::SubWorld_ptr | world,
|  | unsigned int | multiplier
| ) |  |

References paso::util::l2().

Referenced by BOOST_PYTHON_MODULE().

## _multirectangle()

escript::Domain_ptr ripley::_multirectangle | ( | double | _n0,
|  | double | _n1,
|  | const object & | l0,
|  | const object & | l1,
|  | int | d0,
|  | int | d1,
|  | const object & | objpoints,
|  | const object & | objtags,
|  | escript::SubWorld_ptr | world,
|  | unsigned int | multiplier
| ) |  |

Referenced by BOOST_PYTHON_MODULE().

## _rectangle()

escript::Domain_ptr ripley::_rectangle | ( | double | _n0,
|  | double | _n1,
|  | const object & | l0,
|  | const object & | l1,
|  | int | d0,
|  | int | d1,
|  | const object & | objpoints,
|  | const object & | objtags,
|  | escript::SubWorld_ptr | world
| ) |  |

Referenced by BOOST_PYTHON_MODULE().

## byte_swap32()

char* ripley::byte_swap32 | ( | char * | val | ) |

inline

References bswap_32.

Referenced by ripley::Brick::readBinaryGridImpl(), ripley::Rectangle::readBinaryGridImpl(), ripley::Brick::writeBinaryGridImpl(), and ripley::Rectangle::writeBinaryGridImpl().

## byte_swap64()

char* ripley::byte_swap64 | ( | char * | val | ) |

inline

References bswap_64.

Referenced by ripley::Brick::readBinaryGridImpl(), ripley::Rectangle::readBinaryGridImpl(), ripley::Brick::writeBinaryGridImpl(), and ripley::Rectangle::writeBinaryGridImpl().

## doublyLink()

void ripley::doublyLink | ( | std::vector< ripley::IndexVector > & | va,
|  | std::vector< ripley::IndexVector > & | vb,
|  | int | a,
|  | int | b
| ) |  |

inline

sets va[a] = b and vb[b] = a, used in constructing CSC and CSR matrix formats simultaneously

References factorise().

Referenced by ripley::Brick::nodesToDOF(), ripley::Rectangle::nodesToDOF(), and ripley::MultiRectangle::populateDofMap().

## extractPyArray()

template<typename T >

std::vector<T> ripley::extractPyArray | ( | const object & | obj,
|  | const std::string & | name,
|  | int | expectedLength = `0`
| ) |  |

## factorise()

void ripley::factorise | ( | std::vector< int > & | factors,
|  | int | product
| ) |  |

factorises 'product' and inserts the factors into the vector 'factors' in order of smallest to largest

Referenced by ripley::Brick::Brick(), doublyLink(), and ripley::Rectangle::Rectangle().

## indexOfMax()

int ripley::indexOfMax | ( | dim_t | a,
|  | dim_t | b,
|  | dim_t | c
| ) |  |

inline

Referenced by ripley::Brick::Brick().

## isNotEmpty()

bool ripley::isNotEmpty | ( | const std::string | target,
|  | const DataMap & | mapping
| ) |  |

inline

returns true if the given string is in the mapping AND the resulting coefficient is not empty

Referenced by ripley::RipleyDomain::addPDEToTransportProblem(), ripley::RipleyDomain::addToRHS(), ripley::RipleyDomain::addToSystem(), ripley::RipleyDomain::assemblePDE(), ripley::RipleyDomain::assemblePDEBoundary(), ripley::RipleyDomain::assemblePDEDirac(), ripley::WaveAssembler3D::assemblePDESystem(), ripley::WaveAssembler2D::assemblePDESystem(), ripley::LameAssembler3D::assemblePDESystem(), ripley::LameAssembler2D::assemblePDESystem(), ripley::LameAssembler2D::collateFunctionSpaceTypes(), ripley::LameAssembler3D::collateFunctionSpaceTypes(), ripley::WaveAssembler2D::collateFunctionSpaceTypes(), ripley::WaveAssembler3D::collateFunctionSpaceTypes(), ripley::DefaultAssembler3D< Scalar >::collateFunctionSpaceTypes(), and ripley::DefaultAssembler2D< Scalar >::collateFunctionSpaceTypes().

## POINTER_WRAPPER_CLASS()

typedef ripley::POINTER_WRAPPER_CLASS | ( | AbstractAssembler |  | ) |

## readBinaryGrid()

escript::Data ripley::readBinaryGrid | ( | std::string | filename,
|  | escript::FunctionSpace | fs,
|  | const object & | pyShape,
|  | double | fill,
|  | int | byteOrder,
|  | int | dataType,
|  | const object & | pyFirst,
|  | const object & | pyNum,
|  | const object & | pyMultiplier,
|  | const object & | pyReverse
| ) |  |

References ripley::ReaderParameters::byteOrder, ripley::ReaderParameters::dataType, ripley::ReaderParameters::first, escript::FunctionSpace::getDim(), escript::FunctionSpace::getDomain(), ripley::ReaderParameters::multiplier, ripley::ReaderParameters::numValues, ripley::RipleyDomain::readBinaryGrid(), and ripley::ReaderParameters::reverse.

Referenced by BOOST_PYTHON_MODULE(), and ripley::RipleyDomain::getDiracDeltaFunctionsCode().

## readBinaryGridFromZipped()

escript::Data ripley::readBinaryGridFromZipped | ( | std::string | filename,
|  | escript::FunctionSpace | fs,
|  | const object & | pyShape,
|  | double | fill,
|  | int | byteOrder,
|  | int | dataType,
|  | const object & | pyFirst,
|  | const object & | pyNum,
|  | const object & | pyMultiplier,
|  | const object & | pyReverse
| ) |  |

References ripley::ReaderParameters::byteOrder, ripley::ReaderParameters::dataType, ripley::ReaderParameters::first, escript::FunctionSpace::getDim(), escript::FunctionSpace::getDomain(), ripley::ReaderParameters::multiplier, ripley::ReaderParameters::numValues, ripley::RipleyDomain::readBinaryGridFromZipped(), and ripley::ReaderParameters::reverse.

Referenced by BOOST_PYTHON_MODULE(), and ripley::RipleyDomain::getDiracDeltaFunctionsCode().

## readNcGrid()

escript::Data ripley::readNcGrid | ( | std::string | filename,
|  | std::string | varname,
|  | escript::FunctionSpace | fs,
|  | const object & | pyShape,
|  | double | fill,
|  | const object & | pyFirst,
|  | const object & | pyNum,
|  | const object & | pyMultiplier,
|  | const object & | pyReverse
| ) |  |

References ripley::ReaderParameters::first, escript::FunctionSpace::getDim(), escript::FunctionSpace::getDomain(), ripley::ReaderParameters::multiplier, ripley::ReaderParameters::numValues, ripley::RipleyDomain::readNcGrid(), and ripley::ReaderParameters::reverse.

Referenced by BOOST_PYTHON_MODULE(), and ripley::RipleyDomain::getDiracDeltaFunctionsCode().

## tupleListToMap()

void ripley::tupleListToMap | ( | DataMap & | mapping,
|  | const bp::list & | list
| ) |  |

Referenced by ripley::RipleyDomain::addPDEToTransportProblemFromPython(), ripley::RipleyDomain::addToRHSFromPython(), ripley::RipleyDomain::addToSystemFromPython(), and ripley::RipleyDomain::createAssemblerFromPython().

## unpackData()

const escript::Data ripley::unpackData | ( | const std::string | target,
|  | const DataMap & | mapping
| ) |  |

inline

returns the data associated with the string key or an empty data object if the map does not contain the given key

Referenced by ripley::DefaultAssembler2D< Scalar >::assemblePDEBoundarySingle(), ripley::DefaultAssembler3D< Scalar >::assemblePDEBoundarySingle(), ripley::DefaultAssembler2D< Scalar >::assemblePDEBoundarySingleReduced(), ripley::DefaultAssembler3D< Scalar >::assemblePDEBoundarySingleReduced(), ripley::LameAssembler2D::assemblePDEBoundarySystem(), ripley::LameAssembler3D::assemblePDEBoundarySystem(), ripley::DefaultAssembler3D< Scalar >::assemblePDEBoundarySystem(), ripley::DefaultAssembler2D< Scalar >::assemblePDEBoundarySystem(), ripley::DefaultAssembler3D< Scalar >::assemblePDEBoundarySystemReduced(), ripley::DefaultAssembler2D< Scalar >::assemblePDEBoundarySystemReduced(), ripley::RipleyDomain::assemblePDEDirac(), ripley::DefaultAssembler2D< Scalar >::assemblePDESingle(), ripley::DefaultAssembler3D< Scalar >::assemblePDESingle(), ripley::DefaultAssembler2D< Scalar >::assemblePDESingleReduced(), ripley::DefaultAssembler3D< Scalar >::assemblePDESingleReduced(), ripley::WaveAssembler2D::assemblePDESystem(), ripley::WaveAssembler3D::assemblePDESystem(), ripley::LameAssembler3D::assemblePDESystem(), ripley::LameAssembler2D::assemblePDESystem(), ripley::DefaultAssembler3D< Scalar >::assemblePDESystem(), ripley::DefaultAssembler2D< Scalar >::assemblePDESystem(), ripley::DefaultAssembler3D< Scalar >::assemblePDESystemReduced(), and ripley::DefaultAssembler2D< Scalar >::assemblePDESystemReduced().